# -*- coding: utf-8 -*-

"""
neutrinoapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from neutrinoapi.api_helper import APIHelper


class BlocklistSensor(object):

    """Implementation of the 'BlocklistSensor' model.

    Structure of sensors

    Attributes:
        id (int): The sensor ID. This is a permanent and unique ID for each
            sensor
        blocklist (str): The primary blocklist category this sensor belongs to
        description (str): Contains details about the sensor source and what
            type of malicious activity was detected
        additional_properties (Dict[str, Any]): The additional properties for
            the model.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "id": 'id',
        "blocklist": 'blocklist',
        "description": 'description'
    }

    def __init__(self,
                 id=None,
                 blocklist=None,
                 description=None,
                 additional_properties=None):
        """Constructor for the BlocklistSensor class"""

        # Initialize members of the class
        self.id = id 
        self.blocklist = blocklist 
        self.description = description 

        # Add additional model properties to the instance
        if additional_properties is None:
            additional_properties = {}
        self.additional_properties = additional_properties

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        id = dictionary.get("id") if dictionary.get("id") else None
        blocklist = dictionary.get("blocklist") if dictionary.get("blocklist") else None
        description = dictionary.get("description") if dictionary.get("description") else None
        additional_properties = APIHelper.get_additional_properties(
            dictionary={k: v for k, v in dictionary.items() if k not in cls._names.values()},
            unboxing_function=lambda value: value)
        # Return an object of this model
        return cls(id,
                   blocklist,
                   description,
                   additional_properties)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'id={self.id!r}, '
                f'blocklist={self.blocklist!r}, '
                f'description={self.description!r}, '
                f'additional_properties={self.additional_properties!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'id={self.id!s}, '
                f'blocklist={self.blocklist!s}, '
                f'description={self.description!s}, '
                f'additional_properties={self.additional_properties!s})')
