# -*- coding: utf-8 -*-

"""
neutrinoapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from neutrinoapi.api_helper import APIHelper


class EmailVerifyResponse(object):

    """Implementation of the 'EmailVerifyResponse' model.

    Structure of email-verify

    Attributes:
        valid (bool): Is this a valid email address. To be valid an email must
            have: correct syntax, a registered and active domain name, correct
            DNS records and operational MX servers
        verified (bool): True if this email address has passed SMTP username
            verification. Check the 'smtp-status' and 'domain-status' fields
            for specific verification details
        email (str): The complete email address. If you enabled the
            'fix-typos' option then this will be the corrected address
        typos_fixed (bool): True if any typos have been fixed. The 'fix-typos'
            option must be enabled for this to work
        syntax_error (bool): True if this address has any syntax errors or is
            not in RFC compliant formatting
        domain_error (bool): True if this address has any domain name or DNS
            related errors. Check the 'domain-status' field for the detailed
            error reason
        domain (str): The domain name of this email address
        provider (str): The domain name of the email hosting provider
        is_freemail (bool): True if this address is from a free email provider
        is_disposable (bool): True if this address is a disposable, temporary
            or darknet related email address
        is_personal (bool): True if this address likely belongs to a person.
            False if this is a role based address, e.g. admin@, help@,
            office@, etc.
        smtp_status (str): The SMTP username verification status for this
            address: <br> <ul> <li>ok - verification was successful, this is a
            real username that can receive mail</li> <li>absent - this
            username or domain is not registered with the email service
            provider</li> <li>invalid - not a valid email address, check the
            'domain-status' field for specific details</li> <li>unresponsive -
            the mail servers for this domain have repeatedly timed-out or
            refused multiple connection attempts</li> <li>unknown - sorry, we
            could not reliably determine the status of this username</li> </ul>
        smtp_response (str): The raw SMTP response message received during
            verification
        is_catch_all (bool): True if this email domain has a catch-all policy.
            A catch-all domain will accept mail for any username so therefor
            the 'smtp-status' will always be 'ok'
        is_deferred (bool): True if the mail server responded with a temporary
            failure (either a 4xx response code or unresponsive server). You
            can retry this address later, we recommend waiting at least 15
            minutes before retrying
        mx_ip (str): The first resolved IP address of the primary MX server,
            may be empty if there are domain errors present
        domain_status (str): The email domain status, possible values are:
            <br> <ul> <li>ok - the domain is in working order and can receive
            email</li> <li>invalid - the domain is not a conformant hostname.
            May contain invalid syntax or characters</li> <li>no-service - the
            domain owner has indicated there is no mail service on the domain
            (also known as the 'Null MX')</li> <li>no-mail - the domain has no
            valid MX records so cannot receive email</li> <li>mx-invalid - MX
            records contain invalid or non-conformant hostname values</li>
            <li>mx-bogon - MX records point to bogon IP addresses</li>
            <li>resolv-error - MX records do not resolve to any valid IP
            addresses</li> </ul>
        additional_properties (Dict[str, Any]): The additional properties for
            the model.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "valid": 'valid',
        "verified": 'verified',
        "email": 'email',
        "typos_fixed": 'typos-fixed',
        "syntax_error": 'syntax-error',
        "domain_error": 'domain-error',
        "domain": 'domain',
        "provider": 'provider',
        "is_freemail": 'is-freemail',
        "is_disposable": 'is-disposable',
        "is_personal": 'is-personal',
        "smtp_status": 'smtp-status',
        "smtp_response": 'smtp-response',
        "is_catch_all": 'is-catch-all',
        "is_deferred": 'is-deferred',
        "mx_ip": 'mx-ip',
        "domain_status": 'domain-status'
    }

    def __init__(self,
                 valid=None,
                 verified=None,
                 email=None,
                 typos_fixed=None,
                 syntax_error=None,
                 domain_error=None,
                 domain=None,
                 provider=None,
                 is_freemail=None,
                 is_disposable=None,
                 is_personal=None,
                 smtp_status=None,
                 smtp_response=None,
                 is_catch_all=None,
                 is_deferred=None,
                 mx_ip=None,
                 domain_status=None,
                 additional_properties=None):
        """Constructor for the EmailVerifyResponse class"""

        # Initialize members of the class
        self.valid = valid 
        self.verified = verified 
        self.email = email 
        self.typos_fixed = typos_fixed 
        self.syntax_error = syntax_error 
        self.domain_error = domain_error 
        self.domain = domain 
        self.provider = provider 
        self.is_freemail = is_freemail 
        self.is_disposable = is_disposable 
        self.is_personal = is_personal 
        self.smtp_status = smtp_status 
        self.smtp_response = smtp_response 
        self.is_catch_all = is_catch_all 
        self.is_deferred = is_deferred 
        self.mx_ip = mx_ip 
        self.domain_status = domain_status 

        # Add additional model properties to the instance
        if additional_properties is None:
            additional_properties = {}
        self.additional_properties = additional_properties

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        valid = dictionary.get("valid") if "valid" in dictionary.keys() else None
        verified = dictionary.get("verified") if "verified" in dictionary.keys() else None
        email = dictionary.get("email") if dictionary.get("email") else None
        typos_fixed = dictionary.get("typos-fixed") if "typos-fixed" in dictionary.keys() else None
        syntax_error = dictionary.get("syntax-error") if "syntax-error" in dictionary.keys() else None
        domain_error = dictionary.get("domain-error") if "domain-error" in dictionary.keys() else None
        domain = dictionary.get("domain") if dictionary.get("domain") else None
        provider = dictionary.get("provider") if dictionary.get("provider") else None
        is_freemail = dictionary.get("is-freemail") if "is-freemail" in dictionary.keys() else None
        is_disposable = dictionary.get("is-disposable") if "is-disposable" in dictionary.keys() else None
        is_personal = dictionary.get("is-personal") if "is-personal" in dictionary.keys() else None
        smtp_status = dictionary.get("smtp-status") if dictionary.get("smtp-status") else None
        smtp_response = dictionary.get("smtp-response") if dictionary.get("smtp-response") else None
        is_catch_all = dictionary.get("is-catch-all") if "is-catch-all" in dictionary.keys() else None
        is_deferred = dictionary.get("is-deferred") if "is-deferred" in dictionary.keys() else None
        mx_ip = dictionary.get("mx-ip") if dictionary.get("mx-ip") else None
        domain_status = dictionary.get("domain-status") if dictionary.get("domain-status") else None
        additional_properties = APIHelper.get_additional_properties(
            dictionary={k: v for k, v in dictionary.items() if k not in cls._names.values()},
            unboxing_function=lambda value: value)
        # Return an object of this model
        return cls(valid,
                   verified,
                   email,
                   typos_fixed,
                   syntax_error,
                   domain_error,
                   domain,
                   provider,
                   is_freemail,
                   is_disposable,
                   is_personal,
                   smtp_status,
                   smtp_response,
                   is_catch_all,
                   is_deferred,
                   mx_ip,
                   domain_status,
                   additional_properties)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'valid={self.valid!r}, '
                f'verified={self.verified!r}, '
                f'email={self.email!r}, '
                f'typos_fixed={self.typos_fixed!r}, '
                f'syntax_error={self.syntax_error!r}, '
                f'domain_error={self.domain_error!r}, '
                f'domain={self.domain!r}, '
                f'provider={self.provider!r}, '
                f'is_freemail={self.is_freemail!r}, '
                f'is_disposable={self.is_disposable!r}, '
                f'is_personal={self.is_personal!r}, '
                f'smtp_status={self.smtp_status!r}, '
                f'smtp_response={self.smtp_response!r}, '
                f'is_catch_all={self.is_catch_all!r}, '
                f'is_deferred={self.is_deferred!r}, '
                f'mx_ip={self.mx_ip!r}, '
                f'domain_status={self.domain_status!r}, '
                f'additional_properties={self.additional_properties!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'valid={self.valid!s}, '
                f'verified={self.verified!s}, '
                f'email={self.email!s}, '
                f'typos_fixed={self.typos_fixed!s}, '
                f'syntax_error={self.syntax_error!s}, '
                f'domain_error={self.domain_error!s}, '
                f'domain={self.domain!s}, '
                f'provider={self.provider!s}, '
                f'is_freemail={self.is_freemail!s}, '
                f'is_disposable={self.is_disposable!s}, '
                f'is_personal={self.is_personal!s}, '
                f'smtp_status={self.smtp_status!s}, '
                f'smtp_response={self.smtp_response!s}, '
                f'is_catch_all={self.is_catch_all!s}, '
                f'is_deferred={self.is_deferred!s}, '
                f'mx_ip={self.mx_ip!s}, '
                f'domain_status={self.domain_status!s}, '
                f'additional_properties={self.additional_properties!s})')
