# -*- coding: utf-8 -*-

"""
neutrinoapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from neutrinoapi.api_helper import APIHelper


class ExecResult(object):

    """Implementation of the 'ExecResult' model.

    Structure of exec-results

    Attributes:
        statement (str): The JavaScript statement that was executed
        result (str): The result of the executed JavaScript statement. Will be
            empty if the statement returned nothing
        additional_properties (Dict[str, Any]): The additional properties for
            the model.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "statement": 'statement',
        "result": 'result'
    }

    def __init__(self,
                 statement=None,
                 result=None,
                 additional_properties=None):
        """Constructor for the ExecResult class"""

        # Initialize members of the class
        self.statement = statement 
        self.result = result 

        # Add additional model properties to the instance
        if additional_properties is None:
            additional_properties = {}
        self.additional_properties = additional_properties

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        statement = dictionary.get("statement") if dictionary.get("statement") else None
        result = dictionary.get("result") if dictionary.get("result") else None
        additional_properties = APIHelper.get_additional_properties(
            dictionary={k: v for k, v in dictionary.items() if k not in cls._names.values()},
            unboxing_function=lambda value: value)
        # Return an object of this model
        return cls(statement,
                   result,
                   additional_properties)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'statement={self.statement!r}, '
                f'result={self.result!r}, '
                f'additional_properties={self.additional_properties!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'statement={self.statement!s}, '
                f'result={self.result!s}, '
                f'additional_properties={self.additional_properties!s})')
